using System;

using System.Configuration;

namespace TimelineNet.Library
{
    [Serializable()]
    public class HotZoneBand : Band
    {
        public System.Collections.Generic.List<Zone> Zones = new System.Collections.Generic.List<Zone>();
        public HotZoneBand() { }

        public HotZoneBand(int width, Enums.TimelineDateTime TimelineDateTime, int intervalPixels, EventSource EventSource, Theme Theme, System.DateTime InitialDate, int Timezone, bool Overview, decimal TrackGap, decimal trackHeight)
        {
            this.Width = width;
            this.TimelineDateTime = TimelineDateTime;
            this.IntervalPixels = intervalPixels;
            this.EventSource = EventSource;
            this.Theme = Theme;
            this.InitialDate = InitialDate;
            this.Timezone = Timezone;
            this.Overview = Overview;
            this.TrackGap = TrackGap;
            this.TrackHeight = trackHeight;

        }
        public HotZoneBand(int width, Enums.TimelineDateTime TimelineDateTime, int intervalPixels)
        {
            this.Width = width;
            this.TimelineDateTime = TimelineDateTime;
            this.IntervalPixels = intervalPixels;
        }
        public override string ToString()
        {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("Timeline.createHotZoneBandInfo({\n");
            sb.Append("zones: [");
            int count = Zones.Count;
            foreach(Zone z in Zones)
            {
                sb.Append(z.ToString());
                count--;
                if(count > 0) sb.Append(",");
            }

            sb.Append("],");

            sb.Append(base.ToString());
            sb.Append("})\n");

            return sb.ToString();
        }
    }
}