using System;
using System.Collections.Generic;
using System.Text;

namespace TimelineNet.Library.Themes {
    [Serializable()]
    public class ThemeEventBubble {
        public int width;
        public int height;
        public string titleStyler;
        public string bodyStyler;
        public string imageStyler;
        public string wikiStyler;
        public string timeStyler;
        private string themeClientID;
        public string ThemeClientID {
            get { return themeClientID; }
            set { themeClientID = value; }
        }
        public override string ToString() {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            if(width != 0) sb.Append(string.Format("{1}.event.bubble.width={0};\r\n", this.width, ThemeClientID));
            if(height != 0) sb.Append(string.Format("{1}.event.bubble.height={0};\r\n", this.height, ThemeClientID));
            if(titleStyler != null) sb.Append(string.Format("{1}.event.bubble.titleStyler={0};\r\n", this.titleStyler, ThemeClientID));
            if(bodyStyler != null) sb.Append(string.Format("{1}.event.bubble.bodyStyler={0};\r\n", this.bodyStyler, ThemeClientID));
            if(imageStyler != null) sb.Append(string.Format("{1}.event.bubble.imageStyler={0};\r\n", this.imageStyler, ThemeClientID));
            if(wikiStyler != null) sb.Append(string.Format("{1}.event.bubble.wikiStyler={0};\r\n", this.wikiStyler, ThemeClientID));
            if(timeStyler != null) sb.Append(string.Format("{1}.event.bubble.timeStyler={0};\r\n", this.timeStyler, ThemeClientID));
            return sb.ToString();
        }

    }
}
