using System;
using System.Collections.Generic;
using System.Text;

namespace TimelineNet.Library.Themes {
    [Serializable()]
    public class ThemeEventInstant {
        public string icon;
        public string lineColor;
        public string impreciseColor;
        public double impreciseOpacity;
        public bool showLineForNoText;
        private string themeClientID;
        public string ThemeClientID {
            get { return themeClientID; }
            set { themeClientID = value; }
        }
        public override string ToString() {
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            if(this.icon != string.Empty) sb.Append(string.Format("{1}.event.instant.icon='{0}';", icon, ThemeClientID));
            if(this.lineColor != string.Empty) sb.Append(string.Format("{1}.event.instant.lineColor='{0}';", lineColor, ThemeClientID));
            if(this.impreciseColor != string.Empty) sb.Append(string.Format("{1}.event.instant.impreciseColor='{0}';", impreciseColor, ThemeClientID));
            if(this.impreciseOpacity > 0) sb.Append(string.Format("{1}.event.instant.impreciseOpacity={0};", impreciseOpacity, ThemeClientID));
            if(this.showLineForNoText != true) sb.Append(string.Format("{1}.event.instant.showLineForNoText={0};", showLineForNoText.ToString().ToLower(), ThemeClientID));

            return sb.ToString();
        }

    }
}
